Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 4345)
+++ /palm/trunk/SOURCE/pres.f90	(revision 4346)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduction of wall_flags_total_0, which currently sets bits based on static
+! topography information used in wall_flags_static_0
+! 
+! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
 ! 
@@ -72,5 +76,5 @@
         ONLY:  nbgp, ngp_2dh_outer, nx, nxl, nxlg, nxl_mg, nxr, nxrg, nxr_mg,  &
                ny, nys, nysg, nys_mg, nyn, nyng, nyn_mg, nzb, nzt, nzt_mg,     &
-               wall_flags_static_0
+               wall_flags_total_0
 
     USE kinds
@@ -190,5 +194,5 @@
              volume_flow_l(1) = volume_flow_l(1) + u(k,j,i) * dzw(k)           &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 1 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 1 )  &
                                             )
           ENDDO
@@ -209,5 +213,5 @@
              u(k,j,i) = u(k,j,i) + volume_flow_offset(1)                       &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 1 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 1 )  &
                                             )
           ENDDO
@@ -235,5 +239,5 @@
              volume_flow_l(2) = volume_flow_l(2) + v(k,j,i) * dzw(k)           &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 2 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 2 )  &
                                             )
           ENDDO
@@ -254,5 +258,5 @@
              v(k,j,i) = v(k,j,i) + volume_flow_offset(2)                       &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 2 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 2 )  &
                                             )
           ENDDO
@@ -283,5 +287,5 @@
              DO  k = nzb+1, nzt
                 w_l_l(k) = w_l_l(k) + w(k,j,i)                                                     &
-                                     * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 3 ) )
+                                     * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 3 ) )
              ENDDO
           ENDDO
@@ -300,5 +304,5 @@
              DO  k = nzb+1, nzt
                 w(k,j,i) = w(k,j,i) - w_l(k)                                                       &
-                                     * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_static_0(k,j,i), 3 ) )
+                                     * MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_total_0(k,j,i), 3 ) )
              ENDDO
           ENDDO
@@ -347,5 +351,5 @@
                         ) * ddt_3d * d_weight_pres                             &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                            BTEST( wall_flags_static_0(k,j,i), 0 )    &
+                                      BTEST( wall_flags_total_0(k,j,i), 0 )    &
                                           )
           ENDDO
@@ -355,5 +359,5 @@
              threadsum = threadsum + ABS( d(k,j,i) )                           &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                            BTEST( wall_flags_static_0(k,j,i), 0 )    &
+                                      BTEST( wall_flags_total_0(k,j,i), 0 )    &
                                           )
           ENDDO
@@ -372,5 +376,5 @@
     !$OMP DO SCHEDULE( STATIC )
     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-    !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_static_0) &
+    !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_total_0) &
     !$ACC PRESENT(d)
     DO  i = nxl, nxr
@@ -383,5 +387,5 @@
                         ) * ddt_3d * d_weight_pres                             &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                            BTEST( wall_flags_static_0(k,j,i), 0 )    &
+                                      BTEST( wall_flags_total_0(k,j,i), 0 )    &
                                           )     
           ENDDO
@@ -633,5 +637,5 @@
     !$OMP DO
     !$ACC PARALLEL LOOP COLLAPSE(2) PRIVATE(i, j, k) &
-    !$ACC PRESENT(u, v, w, tend, ddzu, wall_flags_static_0)
+    !$ACC PRESENT(u, v, w, tend, ddzu, wall_flags_total_0)
     DO  i = nxl, nxr   
        DO  j = nys, nyn
@@ -642,5 +646,5 @@
                                      * weight_pres_l                           &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 3 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 3 )  &
                                             )
           ENDDO
@@ -651,5 +655,5 @@
                                      * weight_pres_l                           &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 1 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 1 )  &
                                             )
           ENDDO
@@ -660,5 +664,5 @@
                                      * weight_pres_l                           &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 2 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 2 )  &
                                             )
           ENDDO                                                         
@@ -691,5 +695,5 @@
              volume_flow_l(1) = volume_flow_l(1) + u(k,j,nxr) * dzw(k)         &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,nxr), 1 )&
+                                        BTEST( wall_flags_total_0(k,j,nxr), 1 )&
                                             )
           ENDDO
@@ -710,5 +714,5 @@
              volume_flow_l(2) = volume_flow_l(2) + v(k,nyn,i) * dzw(k)         &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,nyn,i), 2 )&
+                                        BTEST( wall_flags_total_0(k,nyn,i), 2 )&
                                             )
            ENDDO
@@ -741,5 +745,5 @@
                 u(k,j,i) = u(k,j,i) + volume_flow_offset(1)                    &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 1 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 1 )  &
                                             )
              ENDDO
@@ -747,5 +751,5 @@
                 v(k,j,i) = v(k,j,i) + volume_flow_offset(2)                    &
                                      * MERGE( 1.0_wp, 0.0_wp,                  &
-                                              BTEST( wall_flags_static_0(k,j,i), 2 )  &
+                                        BTEST( wall_flags_total_0(k,j,i), 2 )  &
                                             )
              ENDDO
@@ -791,5 +795,5 @@
                             w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)           &
                         ) * MERGE( 1.0_wp, 0.0_wp,                             &
-                                   BTEST( wall_flags_static_0(k,j,i), 0 )             &
+                             BTEST( wall_flags_total_0(k,j,i), 0 )             &
                                  )
              ENDDO
@@ -802,5 +806,5 @@
        !$OMP DO SCHEDULE( STATIC )
        !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_static_0) &
+       !$ACC PRESENT(u, v, w, rho_air, rho_air_zw, ddzw, wall_flags_total_0) &
        !$ACC PRESENT(d)
        DO  i = nxl, nxr
@@ -812,5 +816,5 @@
                                w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)        &
                            ) * MERGE( 1.0_wp, 0.0_wp,                          &
-                                   BTEST( wall_flags_static_0(k,j,i), 0 )             &
+                             BTEST( wall_flags_total_0(k,j,i), 0 )             &
                                     )
              ENDDO
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 4345)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 4346)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Introduction of wall_flags_total_0, which currently sets bits based on static
+! topography information used in wall_flags_static_0
+! 
+! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
 ! 
@@ -206,5 +210,5 @@
         ONLY:  advc_flags_s,                                                   &
                nbgp, nxl, nxlg, nxlu, nxr, nxrg, nyn, nyng, nys, nysg, nysv,   &
-               nzb, nzt, wall_flags_static_0
+               nzb, nzt, wall_flags_total_0
 
     USE kinds
@@ -376,5 +380,5 @@
                                                      * ( u(k,j,i) - u_init(k) ) &
                                         ) * MERGE( 1.0_wp, 0.0_wp,              &
-                                                   BTEST( wall_flags_static_0(k,j,i), 1 )&
+                                           BTEST( wall_flags_total_0(k,j,i), 1 )&
                                                  )
              ENDDO
@@ -454,5 +458,5 @@
                                                      * ( v(k,j,i) - v_init(k) )&
                                         ) * MERGE( 1.0_wp, 0.0_wp,             &
-                                                   BTEST( wall_flags_static_0(k,j,i), 2 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 2 )&
                                                  )
              ENDDO
@@ -528,5 +532,5 @@
                                              - tsc(5) * rdf(k) * w(k,j,i)      &
                                      ) * MERGE( 1.0_wp, 0.0_wp,                &
-                                                BTEST( wall_flags_static_0(k,j,i), 3 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 3 )&
                                               )
           ENDDO
@@ -626,5 +630,5 @@
                                           )                                    &
                                        * MERGE( 1.0_wp, 0.0_wp,                &
-                                                BTEST( wall_flags_static_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                               )
              ENDDO
@@ -716,5 +720,5 @@
                                         )                                      &
                                        * MERGE( 1.0_wp, 0.0_wp,                &
-                                                BTEST( wall_flags_static_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                               )                
                 IF ( q_p(k,j,i) < 0.0_wp )  q_p(k,j,i) = 0.1_wp * q(k,j,i)
@@ -814,5 +818,5 @@
                                         )                                      &
                                        * MERGE( 1.0_wp, 0.0_wp,                &
-                                                BTEST( wall_flags_static_0(k,j,i), 0 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 0 )&
                                               )
                 IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
@@ -927,5 +931,5 @@
 !-- Prognostic equation for u-velocity component
     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-    !$ACC PRESENT(u, tend, tu_m, u_init, rdf, wall_flags_static_0) &
+    !$ACC PRESENT(u, tend, tu_m, u_init, rdf, wall_flags_total_0) &
     !$ACC PRESENT(tsc(2:5)) &
     !$ACC PRESENT(u_p)
@@ -938,5 +942,5 @@
                                                         ( u(k,j,i) - u_init(k) ) &
                                      ) * MERGE( 1.0_wp, 0.0_wp,                  &
-                                                 BTEST( wall_flags_static_0(k,j,i), 1 ) &
+                                           BTEST( wall_flags_total_0(k,j,i), 1 ) &
                                               )
           ENDDO
@@ -1030,5 +1034,5 @@
 !-- Prognostic equation for v-velocity component
     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-    !$ACC PRESENT(v, tend, tv_m, v_init, rdf, wall_flags_static_0) &
+    !$ACC PRESENT(v, tend, tv_m, v_init, rdf, wall_flags_total_0) &
     !$ACC PRESENT(tsc(2:5)) &
     !$ACC PRESENT(v_p)
@@ -1041,5 +1045,5 @@
                                                       ( v(k,j,i) - v_init(k) ) &
                                      ) * MERGE( 1.0_wp, 0.0_wp,                &
-                                                BTEST( wall_flags_static_0(k,j,i), 2 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 2 )&
                                               )
           ENDDO
@@ -1129,5 +1133,5 @@
 !-- Prognostic equation for w-velocity component
     !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-    !$ACC PRESENT(w, tend, tw_m, v_init, rdf, wall_flags_static_0) &
+    !$ACC PRESENT(w, tend, tw_m, v_init, rdf, wall_flags_total_0) &
     !$ACC PRESENT(tsc(2:5)) &
     !$ACC PRESENT(w_p)
@@ -1139,5 +1143,5 @@
                                                - tsc(5) * rdf(k) * w(k,j,i)    &
                                      ) * MERGE( 1.0_wp, 0.0_wp,                &
-                                                BTEST( wall_flags_static_0(k,j,i), 3 )&
+                                          BTEST( wall_flags_total_0(k,j,i), 3 )&
                                               )
           ENDDO
@@ -1267,5 +1271,5 @@
 !--    Prognostic equation for potential temperature
        !$ACC PARALLEL LOOP COLLAPSE(3) PRIVATE(i, j, k) &
-       !$ACC PRESENT(pt, tend, tpt_m, wall_flags_static_0) &
+       !$ACC PRESENT(pt, tend, tpt_m, wall_flags_total_0) &
        !$ACC PRESENT(pt_init, rdf_sc, ptdf_x, ptdf_y) &
        !$ACC PRESENT(tsc(3:5)) &
@@ -1281,5 +1285,5 @@
                                           )                                    &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_static_0(k,j,i), 0 )   &
+                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
                                           )
              ENDDO
@@ -1402,5 +1406,5 @@
                                                       ( q(k,j,i) - q_init(k) ) &
                                         ) * MERGE( 1.0_wp, 0.0_wp,             &
-                                                   BTEST( wall_flags_static_0(k,j,i), 0 ) &
+                                         BTEST( wall_flags_total_0(k,j,i), 0 ) &
                                                  )
                 IF ( q_p(k,j,i) < 0.0_wp )  q_p(k,j,i) = 0.1_wp * q(k,j,i)
@@ -1523,5 +1527,5 @@
                                         )                                      &
                                    * MERGE( 1.0_wp, 0.0_wp,                    &
-                                             BTEST( wall_flags_static_0(k,j,i), 0 )   &
+                                       BTEST( wall_flags_total_0(k,j,i), 0 )   &
                                           )
                 IF ( s_p(k,j,i) < 0.0_wp )  s_p(k,j,i) = 0.1_wp * s(k,j,i)
